/* 
 *  Copyright (C) 2005-2007  I-Lun Tseng
 * 
 *  This file is part of OwlVision.
 *
 *  OwlVision is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  OwlVision is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with OwlVision; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */


import java.util.Hashtable;
import java.util.Arrays;

public class CellTableInfo {
	private static Hashtable  cellHT;
	private static Object[]   cellInfoArray; 
	private static Hashtable  dontDisplayCellHT;

	
	public static void addDontDisplayCellHT( String strName ) {
		dontDisplayCellHT.put( strName, strName );
	}
	
	public static void removeDontDisplayCellHT( String strName ) {
		dontDisplayCellHT.remove( strName );
	}
	
	public static boolean mayIdisplayCell( String strName ) {
		if ( dontDisplayCellHT.contains( strName )==true ) {
			return(false);
		}
		return(true);
	}
	
	public static void initialize() {
		cellHT = new Hashtable();
		dontDisplayCellHT = new Hashtable();
	}
	
	public static void insert( String cell_name ) {
	
		if ( cellHT.containsKey( cell_name ) ) {
			return;
		}
		else {		
			cellHT.put( cell_name, cell_name );
		}				
	}
	
	public static void putData() {
		
		cellInfoArray = cellHT.keySet().toArray();
		
		putCellDataToLayerTable();
	}
	
	
	public static void putCellDataToLayerTable() {
		
		CellTable.data = new Object[cellHT.size()][2];
		String[] str_array = new String [cellHT.size()];
		
		for (int i=0; i<cellHT.size(); i++) {
			str_array[i] = cellInfoArray[i].toString();
		}
		Arrays.sort( str_array );
		
		for (int i=0; i<cellHT.size(); i++) {
			//CellTable.data[i][0] = cellInfoArray[i].toString();
			CellTable.data[i][0] = str_array[i] ;
			CellTable.data[i][1] = Boolean.TRUE;
		}		
	}
	
	

}
