/* 
 *  Copyright (C) 2005-2007  I-Lun Tseng
 * 
 *  This file is part of OwlVision.
 *
 *  OwlVision is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  OwlVision is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with OwlVision; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */


public class DSorientationNode {
	
	private boolean				reflection;
	private double				angle;
	private int					shiftX;
	private int					shiftY;
	private DSorientationNode 	next;
	private DSorientationNode	prev;
	
	
	/* Author:  I-Lun Tseng
	 * History: 2006/11/11
	 */
	public DSorientationNode( 	boolean 			r,
								double  			ang,
								int					sX,
								int					sY,
								DSorientationNode 	n ) 
	{
		reflection 	= r;
		angle		= ang;
		shiftX		= sX;
		shiftY		= sY;
		next		= n;
	}
	
	
	/* Author:  I-Lun Tseng
	 * History: 2006/11/11
	 */
	public boolean getReflection() {
		return( reflection );
	}
	
	
	/* Author:  I-Lun Tseng
	 * History: 2006/11/11
	 */
	public double getAngle() {
		return( angle );
	}
	
	
	/* Author:  I-Lun Tseng
	 * History: 2006/11/11
	 */
	public int getShiftX() {
		return( shiftX );
	}
	
	
	/* Author:  I-Lun Tseng
	 * History: 2006/11/11
	 */
	public int getShiftY() {
		return( shiftY );
	}
	
	
	/* Author:  I-Lun Tseng
	 * History: 2006/11/11
	 */
	public DSorientationNode getNext() {
		return( next );
	}
	
	public void setPrev( DSorientationNode p ) {
		prev = p;
	}
	
	public DSorientationNode getPrev() {
		return( prev );
	}
	
	
}
