/* 
 *  Copyright (C) 2005-2007  I-Lun Tseng
 * 
 *  This file is part of OwlVision.
 *
 *  OwlVision is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  OwlVision is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with OwlVision; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */


import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;

public class DrawGrids {
	
	private static boolean isDraw;	// draw Grids or not	
	private static double windowGridSize;

	
	/* ToDo: improve the efficiency of this method */
	public static void draw(Graphics g, int windowWidth, int windowHeight) {
		
		if ( isDraw == false ) {
			return;
		}
		
		/* workaround for efficiency degradation (not a complete solution) */
		if ( ! ( SizeSetting.getOMinX() <= 0 && 0 <= SizeSetting.getOMaxX() &&
			     SizeSetting.getOMinY() <= 0 && 0 <= SizeSetting.getOMaxY() ) )
		{
			return;
		}
		
    	Graphics2D graph2d = (Graphics2D) g;    	
    	//graph2d.setPaint( Color.gray );
    	//Color.gray = (128,128,128)
    	graph2d.setPaint( new Color(128,128,128,128) );    	    	
    	
    	graph2d.setStroke(new BasicStroke((float)1));    	
    	
    	double GDSIIunitSize = 1/SizeSetting.getUserUnit();
    	
    	// translate GDSII --> Window
    	int originWindowX = SizeSetting.transGDS2Window_X_int( 0 );
    	int originWindowY = SizeSetting.transGDS2Window_Y_int( 0 );    	
    	//System.out.println("window center: " + originWindowX + ", " + originWindowY );
    	
    	//int windowGridSize =  SizeSetting.transGDS2Window_X( GDSIIunitSize ) - SizeSetting.transGDS2Window_X( 0 );
    	
    	for ( windowGridSize = SizeSetting.transGDS2Window_X_int( GDSIIunitSize ) - SizeSetting.transGDS2Window_X_int( 0 );
    		  windowGridSize < 19;
    		  GDSIIunitSize *= 2 ) 
    	{
    		windowGridSize = SizeSetting.transGDS2Window_X_int( GDSIIunitSize ) - SizeSetting.transGDS2Window_X_int( 0 );
    	}
    	
    	//System.out.println("windowGridSize: " + windowGridSize );
    	
    	Shape rect;
    	
    	/* quadrant 4 */
    	for (int y=originWindowY; y<windowHeight; y += windowGridSize ) {
    		for (int x=originWindowX; x<windowWidth; x += windowGridSize ) {
    			rect = new Rectangle2D.Double( x, y, 0.9, 0.9);
    	    	graph2d.draw(rect);    			
    		}
    	}
    	/* quadrant 3 */
    	for (int y=originWindowY; y<windowHeight; y += windowGridSize ) {
    		for (int x=originWindowX; x>0; x -= windowGridSize ) {
    			rect = new Rectangle2D.Double( x, y, 0.9, 0.9);
    	    	graph2d.draw(rect);    			
    		}
    	}
    	/* quadrant 2 */
    	for (int y=originWindowY; y>0; y -= windowGridSize ) {
    		for (int x=originWindowX; x>0; x -= windowGridSize ) {
    			rect = new Rectangle2D.Double( x, y, 0.9, 0.9);
    	    	graph2d.draw(rect);    			
    		}
    	}
    	/* quadrant 1 */
    	for (int y=originWindowY; y>0; y -= windowGridSize ) {
    		for (int x=originWindowX; x<windowWidth; x += windowGridSize ) {
    			rect = new Rectangle2D.Double( x, y, 0.9, 0.9);
    	    	graph2d.draw(rect);    			
    		}
    	}    	    	
    }  
	
	public static double getWindowGridSizeDouble() {
		return( windowGridSize );
	}
	
	public static int getWindowGridSizeInt() {
		return( (int)windowGridSize );
	}
	
	public static void setState(boolean state) {
		isDraw = state;
	}
	
	public static boolean getState() {
		return( isDraw );
	}
	
	
}
