/* 
 *  Copyright (C) 2005-2007  I-Lun Tseng
 * 
 *  This file is part of OwlVision.
 *
 *  OwlVision is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  OwlVision is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with OwlVision; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */


/*
 * Created on 2005/4/2
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
import java.io.*;

/**
 * @author I-Lun Tseng
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class GDSII {	
	
	//public static String dataStr;
	public static int dataInt;
	public static int record_size;
	
	private static String 			filename;
	private static File				file;
	private static FileInputStream 	gdsii_stream;
	private static BufferedInputStream gdsii_stream_b;
	private static long fileSize;
	private static long filePointerLocation;
	public static double progressVal;
	private static boolean isReady;
	
	//private static int counter=0;

    // constructor
    public GDSII( String fileName ) {
        filename = fileName;
        file = new File(filename);
        
        MainClass.intFrame01.setTitle("Layout View - [" + file.getAbsolutePath() + "]");
        
        // check the existance of the file
        if (!file.exists()) {
            System.out.println("No such file!");
            System.exit(1);
        }
        
        fileSize = file.length();
        filePointerLocation = 0;
        //System.out.println("fileSize: " + fileSize + "," + filePointerLocation);
        
        try {
        	gdsii_stream = new FileInputStream(file);   
        	gdsii_stream_b = new BufferedInputStream( gdsii_stream, 1048576 );
        }
        catch (FileNotFoundException e) {
        	System.out.println("No such file: \"" + filename + "\";");
            System.exit(1);
        } 
    }  // GDSII
    
    public static int read_record() {
    	
    	read();
    	record_size = (dataInt/2)-2;
    	 
    	return( read() );
    }

    public static int read() {

        try {
            byte[] buffer = new byte[2]; /* 2 bytes = 16 bits */
            int tmp1, tmp2, tmp3;

            // if ((bytes_read = gdsii_stream.read(buffer)) != -1) {
            if ( (gdsii_stream_b.read(buffer)) != -1 ) {

                tmp1 = (int) buffer[0];
                tmp1 = tmp1 << 8;
                tmp1 = tmp1 & 0x0000FF00;
                tmp2 = (int) buffer[1];
                tmp2 = tmp2 & 0x000000FF;
                tmp3 = tmp1 | tmp2;
                
                /* This commented section can be used as GDSII Hex Dump */
                /*
                if (isDataStrRequired==true) {
                	String HexString = Integer.toHexString(tmp3);
                	switch (HexString.length()) {
                    	case 1:
                    		HexString = "000" + HexString;
                    		break;
                    	case 2:
                    		HexString = "00" + HexString;
                    		break;
                    	case 3:
                    		HexString = "0" + HexString;
                    		break;
                	}
                	String dataStr = HexString.toUpperCase();
                	System.out.println("" + dataStr + " ");
                }  
                */
                
                dataInt = tmp3;
                
                filePointerLocation += 2;
            	progressVal = (double)filePointerLocation/(double)fileSize;
            	//PanelStatusBar.setProgress(progressVal);
            	
                return(2);  /* # of bytes read */
            }  // if
            else {
                return(0);	
            }
        } catch (IOException e) {
        	// do nothing
        }                
        return(0);
    }
    
    public static boolean isReady() {
    	return(isReady);
    }
    
    public static void setReady(boolean is_ready) {
    	isReady = is_ready;
    }
    
    /* close the GDSII file */
    public static void closeFile() 
    {
    	MainClass.intFrame01.setTitle("Layout View");
    	
    	try {
			gdsii_stream_b.close();
			gdsii_stream.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		DSbuild.reset();
		setReady(false);
		DrawLayout.clearDisplay();
		PanelStatusBar.showCoord(0,0); // disable the coordinate display
    }
    
    
    /* Author:  I-Lun Tseng
     * History: 2006/11/24
     */
    public static String getFileName() 
    {
    	return( filename );
    }
    
    
} // GDSII
