/* 
 *  Copyright (C) 2005-2007  I-Lun Tseng
 * 
 *  This file is part of OwlVision.
 *
 *  OwlVision is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  OwlVision is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with OwlVision; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */


public class Intersection {
	
	/*                   (x1,y1)
	 *                       \
	 *                        \
	 *                         \
	 *                          \ intersection point: ( intersectionX, horizontalY )
	 *   horizontalY  -----------o----------------------------
	 *                            \
	 *                             \
	 *                              \
	 *                               \
	 *                             (x2,y2)
	 */
	public static PointInt findIntersectionWithHorizontalLine( int x1, int y1, int x2, int y2, int horizontalY ) 
			//DSxyDNode n, double scanLinePos ) {
	{
		
		
		double x_1 = x1;
		double y_1 = y1;
		double x_2 = x2;
		double y_2 = y2;
		
		if ( y_1 == horizontalY ) {
			return( new PointInt( (int)x_1, horizontalY ) );
		}
		else if ( y_2 == horizontalY ) {
			return( new PointInt( (int)x_2, horizontalY ) );
		}
		
		double intersectionX = ((y_1-horizontalY)*(x_1-x_2)-x_1*y_1+x_1*y_2) / (y_2-y_1);
		
		return( new PointInt( (int)intersectionX, horizontalY ) );
		
	}
	
	

}
