/* 
 *  Copyright (C) 2005-2007  I-Lun Tseng
 * 
 *  This file is part of OwlVision.
 *
 *  OwlVision is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  OwlVision is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with OwlVision; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */

import java.util.Hashtable;

import javax.swing.JOptionPane;


/* Author:  I-Lun Tseng
 * History: 2006/11/24
 */
/* Store GDSII records that are not supported, 
 * so that the warning message for an unsupported GDSII record is shown once.
 */
public class UnsupportedGDSIIrecords {
	
	private Hashtable	ht;
	
	
	public UnsupportedGDSIIrecords() {
		ht = new Hashtable();
	}
	
	
	public void showConsoleMsg( String gdsiiRecord ) {
		
		if ( ht.containsKey( gdsiiRecord ) == false )
		{
			OwlVisionMessages.showConsoleMsg( JOptionPane.WARNING_MESSAGE, 30000, gdsiiRecord );
			ht.put( gdsiiRecord, gdsiiRecord );
		}
		
	}
	
	
	

}
